MODULE 'exec/memory',
			 'intuition/intuition','intuition/screens','intuition/gadgetclass',
			 'intuition/screens',
			 'graphics/rastport','graphics/gfx','graphics/text',
			 'graphics/view',
			 'libraries/iffparse','iffparse',
			 'dos/dos','dos/dosextens','dos/dosasl','exec/tasks',
			 'dos/notify','exec/ports'

	OBJECT bitmapheader
		w:INT;h:INT;x:INT;y:INT
		depth:CHAR;masking:CHAR
		compression:CHAR;pad1:CHAR;transparentcolor:INT
		xaspect:CHAR;yaspect:CHAR;pagewidth:INT;pageheight:INT
	ENDOBJECT
	DEF source[250]:STRING
	DEF argarray[11]:LIST
	DEF	iff=NIL:PTR TO iffhandle
	DEF	ierror
	DEF tryagain=0
	DEF sp=NIL:PTR TO storedproperty
	DEF body
	DEF ditz,dang,dumb
->	DEF vp=NIL:PTR TO viewport
	DEF cm
	DEF depth,scratch
	DEF rdarg
	DEF viewport=NIL:PTR TO viewport
	DEF scr=NIL:PTR TO screen,oldscr
	DEF bitmap=NIL:PTR TO bitmap
	DEF quiet=FALSE
	DEF lock[260]:LIST
	DEF lockmode=0 /* 0 means don't lock unless in palette*/
	DEF force=0	/* 0 means don't override already locked pens! */

	DEF sw,sh,sb:PTR TO bitmap,sli,sf,svp,sbh,srpf,srp:PTR TO rastport,sbd
	DEF osw,osh,osb:PTR TO bitmap,osli,osf,osvp,osbh,osrpf,osrp:PTR TO rastport,osbd

	DEF fnotify=0:PTR TO notifyrequest
	DEF fport=0:PTR TO mp,sig
	DEF fmsg=0:PTR TO notifymessage

	DEF snotify=0:PTR TO notifyrequest

	DEF pnotify=0:PTR TO notifyrequest

	DEF notify=FALSE,notifyloop=FALSE

	DEF wbverlauf=FALSE,wbverlauftask=0
	DEF tries

PROC main() HANDLE
	IF KickVersion(39)=NIL
		WriteF('\nGet OS3.x (maybe a nice A1200?)\n')
		CleanUp(21)
	ENDIF
	IF (wbmessage)
		WriteF('\nCannot be run from WorkBench.\n\n(Press RETURN to close this window.)\n')
		CleanUp(21)
	ENDIF
	NEW fnotify,snotify,pnotify

	iffparsebase:=OpenLibrary('iffparse.library',39)

	rdarg:=ReadArgs('FILE/A,Q=QUIET/S,F=FORCE/S,LA=LOCKALL/S,N=NOTIFY/S,WBV=SIGNALWBVERLAUF/S',argarray,0)
	IF rdarg>0
		IF argarray[0]<>NIL
			StrCopy(source,argarray[0],ALL)
		ENDIF
		IF argarray[1]<>NIL
			quiet:=TRUE
		ENDIF
		IF argarray[2]<>NIL
			force:=TRUE
		ENDIF
		IF argarray[3]<>NIL
			lockmode:=TRUE
		ENDIF
		IF argarray[4]<>NIL
			notify:=TRUE
		ENDIF
		IF argarray[5]<>NIL
			wbverlauf:=TRUE
		ENDIF
		FreeArgs(rdarg)
	ELSE
		Raise(1)
	ENDIF
	notifyloop:=TRUE
	WHILE (notifyloop=TRUE)
		IF (scr := LockPubScreen({work})) = NIL
			Raise(1)
		ELSE
			bitmap:=scr.bitmap
			viewport:=scr.viewport
			depth:=bitmap.depth
			cm:=viewport.colormap
		ENDIF
		iff:=AllocIFF()
		iff.stream:=Open(source,MODE_OLDFILE)
		IF (iff.stream)
			InitIFFasDOS(iff)
		ELSE
			Raise(1)
		ENDIF
		ierror:=OpenIFF(iff,IFFF_READ)
		ierror:=PropChunk(iff,"ILBM","LOCK")
		ierror:=PropChunk(iff,"ILBM","CMAP")
		ierror:=StopOnExit(iff,"ILBM","FORM")
		ierror:=ParseIFF(iff,IFFPARSE_SCAN)

		IF(sp:=FindProp(iff,"ILBM","LOCK"))
			body:=sp.data
			FOR scratch:=0 TO (sp.size-1)
				ditz:=Char(body++)
				IF lockmode=0
					lockpen(scratch,ditz)
				ELSE
					lockpen(scratch,1)
				ENDIF
			ENDFOR
		ENDIF
		IF(sp:=FindProp(iff,"ILBM","CMAP"))
			body:=sp.data
			FOR scratch:=0 TO (sp.size/3)-1
				ditz:=Char(body++)
				dang:=Char(body++)
				dumb:=Char(body++)
				IF (scratch<(Shl(1,depth)))
					IF lock[scratch]=FALSE
						setrgb32(viewport,scratch,ditz,dang,dumb)
					ENDIF
					IF force
						setrgb32(viewport,scratch,ditz,dang,dumb)
					ENDIF
				ENDIF
			ENDFOR
		ELSE
			Raise(1)
		ENDIF
		IF (notify=0)
			notifyloop:=FALSE
		ELSE
			IF scr			->		KLUDGE KLUDGE KLUDGE  (but aren't all screen-change detection routines?!??)
				osw:=scr.width
				osh:=scr.height
				osb:=scr.bitmap
				osbd:=osb.depth
				osli:=scr.layerinfo
				osf:=scr.font
				osvp:=scr.viewport
				osbh:=scr.barheight
				osrp:=scr.rastport
				osrpf:=osrp.font
				UnlockPubScreen(0,scr);oldscr:=scr;scr:=0
				IF (fport=0) THEN fport:=CreateMsgPort()
				IF (fport)
					fnotify.name:='env:sys/screenmode.prefs'
					fnotify.flags:=NRF_SEND_MESSAGE
					fnotify.port:=fport
					snotify.name:='env:sys/font.prefs'
					snotify.flags:=NRF_SEND_MESSAGE
					snotify.port:=fport
					pnotify.name:=source
					pnotify.flags:=NRF_SEND_MESSAGE
					pnotify.port:=fport
					IF ((StartNotify(fnotify)) AND (StartNotify(snotify)) AND (StartNotify(pnotify)))
						IF (tryagain=0) THEN sig:=Wait(SIGBREAKF_CTRL_C OR (Shl(1,fport.sigbit)))
						IF (sig AND SIGBREAKF_CTRL_C)
							notifyloop:=FALSE
						ENDIF
						IF (sig AND Shl(1,fport.sigbit))
							IF ((fmsg:=GetMsg(fport)) OR (tryagain<>0))
								tryagain:=0
								IF (fmsg) THEN ReplyMsg(fmsg)
								tries:=0
								Delay(60)	-> Wait a bit, then we begin to bang on intuition...
								REPEAT
									Forbid()
									scr:=LockPubScreen({work})
									IF (scr)
										sw:=scr.width
										sh:=scr.height
										sb:=scr.bitmap
										sbd:=sb.depth
										sli:=scr.layerinfo
										sf:=scr.font
										svp:=scr.viewport
										sbh:=scr.barheight
										srp:=scr.rastport
										srpf:=osrp.font
										UnlockPubScreen(0,scr)
										Permit()
									ELSE
										Permit()
										Delay(30)
									ENDIF
									tries:=tries+1
								UNTIL (((scr>0) AND (oldscr<>scr)) OR (tries>=16) OR (sw<>osw) OR (sh<>osh) OR (sb<>osb) OR (sli<>osli) OR (sf<>osf) OR (svp<>osvp) OR (sbh<>osbh) OR (srp<>osrp) OR (srpf<>osrpf) OR (sbd<>osbd))
								IF (tries>=14) THEN tryagain:=TRUE
								scr:=0
								IF (wbverlauf)
									wbverlauftask:=FindTask('WBVerlauf')
									IF (wbverlauftask)
										Signal(wbverlauftask,$FFFF0FFF)
									ENDIF
								ENDIF
							ENDIF
						ENDIF
						EndNotify(fnotify)
						EndNotify(snotify)
						EndNotify(pnotify)
					ENDIF
					IF CtrlC()
						notifyloop:=FALSE
					ENDIF
				ELSE
					notifyloop:=FALSE
				ENDIF
			ENDIF
		ENDIF		
		IF CtrlC() THEN (notifyloop:=FALSE)
	ENDWHILE
EXCEPT DO
	IF ((notify) AND (quiet=FALSE)) THEN WriteF('***BREAK\n')
	IF (fport)
		IF (fnotify) THEN EndNotify(fnotify)
		IF (snotify) THEN EndNotify(snotify)
		IF (pnotify) THEN EndNotify(pnotify)
		DeleteMsgPort(fport)
	ENDIF

	END fnotify,snotify,pnotify
	IF scr THEN UnlockPubScreen(0,scr)
	IF (iff)
		CloseIFF(iff)
		IF (iff.stream) THEN Close(iff.stream)
		FreeIFF(iff)
	ENDIF
	IF iffparsebase THEN CloseLibrary(iffparsebase)
	IF ((exception) AND (quiet=FALSE)) THEN WriteF('ShoveColors Failed.\n')
ENDPROC

PROC getrgb32(cm,fc,nc,tab)
	DEF ret
	MOVE.L cm,A0
	MOVE.L fc,D0
	MOVE.L nc,D1
	MOVE.L tab,A1
	MOVE.L gfxbase,A6
	JSR    -$384(A6)
	MOVE.L D0,ret
ENDPROC ret

PROC setrgb32(vp,pen,red,green,blue)
	MOVE.L vp,A0
  MOVE.L pen,D0
  MOVE.L red,D1
  SWAP   D1
  LSL.L  #8,D1
  MOVE.L green,D2
  SWAP   D2
  LSL.L  #8,D2
  MOVE.L blue,D3
  SWAP   D3
  LSL.L  #8,D3
  MOVE.L gfxbase,A6
  JSR    -$354(A6)
ENDPROC

PROC obtainpen(cm,n,r,g,b,f)
	DEF ret
	MOVE.L gfxbase,A6
	MOVE.L n,D0
  MOVE.L r,D1
  SWAP   D1
  LSL.L  #8,D1
  MOVE.L g,D2
  SWAP   D2
  LSL.L  #8,D2
  MOVE.L b,D3
  SWAP   D3
  LSL.L  #8,D3
	MOVE.L cm,A0
	MOVE.L f,D4
	JSR    -$3BA(A6)
	MOVE.L D0,ret
ENDPROC ret

PROC releasepen(cm,n)
	MOVE.L cm,A0
	MOVE.L n,D0
	MOVE.L gfxbase,A6
	JSR    -$3B4(A6)
ENDPROC

PROC lockpen(pn,mode)

	DEF cmtable,red,green,blue,dummy

	cmtable:=[0,0,0,0,0,0]:LONG
	getrgb32(cm,pn,1,cmtable)
	red:=Char(cmtable)
	green:=Char(cmtable+4)
	blue:=Char(cmtable+8)

	dummy:=obtainpen(cm,pn,red,green,blue,0)

	IF dummy<0
		lock[pn]:=TRUE /* Pen was unavailable, so DON'T release/change! */
	ELSE
		IF (mode=0) /* Was able to lock, but it needs to be *free* */
			releasepen(cm,pn)
		ENDIF
		lock[pn]:=FALSE
	ENDIF
ENDPROC

versionstring:
CHAR '\0$VER: shovecolors 0.4 (27.3.95)\0'

work:
CHAR 'Workbench\0\0'
